#include "stdafx.h"
#include <code/extgl.h>
#include <GL/glu.h>
#include <vcg/Point3.h>
using namespace vcg;

#include <vcg/CIGLFont.h>
#include <vcg/CIMsg.h>


void CIGLFont::Print(const char *pchar, Point3f &p)
{
  if(!pchar) return;
	glPushAttrib(GL_ENABLE_BIT|GL_LIST_BIT|GL_CURRENT_BIT); // Pushes the display list bits 
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_1D);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_TEXTURE_CUBE_MAP);
  
  glRasterPos3d(p[0],p[1],p[2]);
	glListBase(dlbase); //Setting start element
  glCallLists(strlen(pchar), GL_UNSIGNED_BYTE, pchar); // Draws the display list text
  glPopAttrib();
}

void CIGLFont::Init(const char *fontname, int size)
{
	TRACE("Creating Fonts\n");
	HDC h_DC =::GetDC(0);
  HFONT font; // Windows Font ID
  dlbase= glGenLists(255); // Storage for 255 characters

	font = ::CreateFont(-size, // Height Of Font
         0, // Width Of Font
         0, // Angle Of Escapement
         0, // Orientation Angle
         FW_REGULAR, // Font Weight
         0, // Italic
         0, // Underline
         0, // Strikeout
         ANSI_CHARSET, // Character Set Identifier 
         OUT_TT_PRECIS, // Output Precision 
         CLIP_DEFAULT_PRECIS, // Clipping Precision 
         ANTIALIASED_QUALITY, // Output Quality
         FF_DONTCARE | DEFAULT_PITCH, // Family And Pitch
         fontname); // Font Name

  SelectObject(h_DC, font); // Selects The Font We Want 
  wglUseFontBitmaps(h_DC, 0, 255, dlbase); // Builds 255 characters
	::DeleteObject(font);
}

void CIGLFont::OrthoPrint(const char *pchar, Point3f &p)
{
	int vp[4];
	glGetIntegerv(GL_VIEWPORT,vp);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	// lo stack delle matrici di proiezione  di solito profondo 2, 
	// quindi puo' capitare di fare stack overflow. Meglio controllare.
	CIMsg::checkGLError("CIGLFont::OrthoPrint::glPushMatrix"); 
	glLoadIdentity();
	gluOrtho2D(vp[0], vp[0]+vp[2], vp[1], vp[1]+vp[3]);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	Print(pchar,p);
	
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}